/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android;

/**
 * A super-interface for all interfaces that support listeners being added and
 * removed.
 * 
 * @param <ListenerType> the type of listener.
 */
public interface ListenerTarget<ListenerType>
{
    /**
     * Adds a listener to this target.
     * 
     * @param listener the listener.
     */
    void addListener(ListenerType listener);

    /**
     * Removes a listener to this target.
     * 
     * @param listener the listener.
     */
    void removeListener(ListenerType listener);
}
