/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.aed;

/**
 * Allows data sharing between users by creation of topics to which data can be
 * added.
 */
public interface AED
{
    /**
     * Creates and connects to a topic. A user will then be able to add, remove
     * data, receive updates and send messages to the topic.
     *
     * @param topicName The name of the topic, which is also its unique
     *            identifier.
     * @param listener The topic listener.
     * @return the topic.
     */
    Topic createTopic(String topicName, TopicListener listener);

    /**
     * Creates and connects to a topic with the given expiry time. A user will
     * then be able to add, remove data, receive updates and send messages to
     * the topic.
     *
     * @param topicName The name of the topic, which is also its unique
     *            identifier.
     * @param expiryTime The expiry time in minutes.
     * @param listener The topic listener.
     * @return the topic.
     */
    Topic createTopic(String topicName, int expiryTime, TopicListener listener);
}
