/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.aed.impl;

import org.json.JSONObject;

import com.alicecallsbob.fcsdk.android.aed.Topic;
import com.alicecallsbob.fcsdk.android.aed.TopicListener;
import com.alicecallsbob.fcsdk.android.impl.ServerMessageListenerTargetImpl;
import com.alicecallsbob.fcsdk.android.impl.ServerMessageManager;

public class TopicImpl extends ServerMessageListenerTargetImpl<TopicListener> implements Topic
{
    private final String name;
    private boolean connected;

    public TopicImpl(ServerMessageManager serverMessageManager, TopicListener listener, String name)
    {
        super(serverMessageManager);
        addListener(listener);
        this.name = name;
        this.connected = false;
    }

    @Override
    public String getName()
    {
        return name;
    }

    @Override
    public boolean isConnected()
    {
        return connected;
    }

    public void setConnected(boolean connected)
    {
        this.connected = connected;
    }

    @Override
    public void disconnect()
    {
        final JSONObject json = AEDServerMessageBuilder.createUnsubscribeMessage(name);
        sendServerMessage(json);
    }

    @Override
    public void disconnect(boolean deleteTopic)
    {
        if (deleteTopic)
        {
            final JSONObject json = AEDServerMessageBuilder.createDeleteTopicMessage(name);
            sendServerMessage(json);
        }
        else
        {
            disconnect();
        }
    }

    @Override
    public void submitData(String key, String value)
    {
        final JSONObject json = AEDServerMessageBuilder.createPublishDataMessage(name, key, value);
        sendServerMessage(json);
    }

    @Override
    public void deleteData(String key)
    {
        final JSONObject json = AEDServerMessageBuilder.createDeleteDataMessage(name, key);
        sendServerMessage(json);
    }

    @Override
    public void sendAedMessage(String aedMessage)
    {
        final JSONObject json = AEDServerMessageBuilder.createAedMessage(name, aedMessage);
        sendServerMessage(json);
    }
}
