/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.aed.impl.handler;

import org.json.JSONException;
import org.json.JSONObject;

import com.alicecallsbob.fcsdk.android.aed.impl.AEDManager;
import com.alicecallsbob.fcsdk.android.aed.impl.AEDServerMessageBuilder;

public class TopicUpdatedHandler extends AEDServerMessageHandler
{
    public TopicUpdatedHandler(AEDManager aedManager)
    {
        super(aedManager);
    }

    @Override
    public void handleServerMessage(JSONObject serverMessage) throws JSONException
    {
        final String name = serverMessage.getString(AEDServerMessageBuilder.MESSAGE_FIELD_TOPIC);
        final String key = serverMessage.getString(AEDServerMessageBuilder.MESSAGE_FIELD_KEY);
        final String value = serverMessage.getString(AEDServerMessageBuilder.MESSAGE_FIELD_VALUE);
        final int version = serverMessage.getInt(AEDServerMessageBuilder.MESSAGE_FIELD_VERSION);
        final boolean deleted = serverMessage.getBoolean(AEDServerMessageBuilder.MESSAGE_FIELD_DELETED);
        getAEDManager().onTopicUpdated(name, key, value, version, deleted);
    }
}
