/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.impl;

import java.util.Collection;
import java.util.HashSet;

import com.alicecallsbob.fcsdk.android.ListenerTarget;

public abstract class ListenerTargetImpl<ListenerType> implements ListenerTarget<ListenerType>
{
    private final Collection<ListenerType> listeners = new HashSet<ListenerType>();

    @Override
    public void addListener(ListenerType listener)
    {
        if (listener != null)
        {
            listeners.add(listener);
        }
    }

    @Override
    public void removeListener(ListenerType listener)
    {
        if (listener != null)
        {
            listeners.remove(listener);
        }
    }

    public Iterable<ListenerType> listeners()
    {
        return listeners;
    }
}
