/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.phone;

/**
 * Thrown when there is an error during call creation. This should include a
 * {@link CallCreationError}.
 */
public class CallCreationWithErrorException extends CallCreationException
{
	/** Serial Number */
	private static final long serialVersionUID = 1L;

	/** Reason why the call creation failed */
	private CallCreationError creationError;

	public CallCreationWithErrorException(String message,
	        CallCreationError creationError)
	{
		super(message);
		this.creationError = creationError;
	}

	/**
	 * Get the error which caused the call creation to fail
	 * 
	 * @return the error
	 */
	public CallCreationError getCallCreationError()
	{
		return creationError;
	}
}
