/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.phone;

/**
 * An enumeration of all call statuses.
 * 
 * WARNING: Order is important, beware when adding new statuses
 */
public enum CallStatus
{
	/** The call has not been initialized yet */
	UNINITIALIZED,
    /** The call is in a process of being setup. */
    SETUP,
    /** The call is ringing/alerting locally - incoming call. */
    ALERTING,
    /** The call is ringing on the remote side - outgoing call. */
    RINGING,
    /** The call is connected and waiting for media streams to establish. */
    MEDIA_PENDING,
    /** The call is in progress and streaming media. */
    IN_CALL,   
    /** The dialled number is busy. */
    BUSY,
    /** The dialled number was unreachable. */
    NOT_FOUND,
    /** The dialled number timed out. */
    TIMED_OUT,
    /** The Media Broker has reached capacity */
    NO_MB_CAPACITY,
    /** The request was terminated by the network */
    REQUEST_TERMINATED,
    /** An entity on the network was unavailable */
    TEMPORARILY_UNAVAILABLE,
    /** Unable to access media */
    MEDIA_UNAVAILABLE,
    /** The call has errored. */
    ERROR,
    /** The call has ended. */
    ENDED;
   
}
