/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.phone;

/**
 * A listener for the {@link Phone} that will be informed of events.
 */
public interface PhoneListener
{
    /**
     * A notification to indicate an incoming call.
     * 
     * @param call The incoming call.
     */
    void onIncomingCall(Call call);
    
    /**
     * A notification to indicate a capture setting change.
     * 
     * @param setting The new capture setting
     * @param camera The camera id
     */
    void onCaptureSettingChange(PhoneVideoCaptureSetting setting, int camera);
    
    /**
     * A callback notification indicating that the local media stream was added.
     */
    void onLocalMediaStream();
}
