/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.phone.impl.handlers;

import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.acbrtc.PeerConnection.IceServer;

import android.util.Log;

import com.alicecallsbob.fcsdk.android.phone.impl.CallServerMessageBuilder;
import com.alicecallsbob.fcsdk.android.phone.impl.PhoneImpl;

public class CallConfigMessageHandler extends CallServerMessageHandler
{
	private final String TAG = "CallConfigMessageHandler";

	public CallConfigMessageHandler(PhoneImpl callManager)
	{
		super(callManager);
	}

	@Override
	public void handleServerMessage(JSONObject serverMessage) throws JSONException
	{
		final String callID = serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_CALL_ID);

		JSONArray iceServers = serverMessage.getJSONArray(CallServerMessageBuilder.MESSAGE_FIELD_CALL_CONFIG_ICE_SERVERS);

		List<IceServer> servers = new Vector<IceServer>();
		
		for (int i = 0; i < iceServers.length(); i++)
		{
			JSONObject is = (JSONObject) iceServers.get(i);
			
			String username = is.getString(CallServerMessageBuilder.MESSAGE_FIELD_CALL_CONFIG_USERNAME);
			String credential = is.getString(CallServerMessageBuilder.MESSAGE_FIELD_CALL_CONFIG_CREDENTIAL);
			
			final JSONArray urls = is.getJSONArray(CallServerMessageBuilder.MESSAGE_FIELD_CALL_CONFIG_URLS);
			
			for (int j = 0; j < urls.length(); j++)
			{
				String url = (String) urls.getString(j);
				
				Log.d(TAG, "handleServerMessage adding IceServer " + username + " " + credential + " " + url);
				
				if (url == null)
				{
					continue;
				}
				
				if (username == null)
				{
					username = "";
				}
				
				if (credential == null)
				{
					credential = "";
				}
				
				StringTokenizer st = new StringTokenizer(url, ";");
				
				while (st.hasMoreTokens()) 
				{
					String uri = st.nextToken();
					
					Log.i(TAG, "TURN server added " + uri + " - " + username + " " + credential);

					IceServer server = new IceServer(uri, username, credential);
					servers.add(server);
			    }
			}
		}
		
		Log.i(TAG, "TURN servers specified in CALL_CONFIG " + servers.size());

		getCallManager().handleCallConfig(callID, servers);
	}
}
