/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.phone.impl.handlers;

import org.json.JSONException;
import org.json.JSONObject;
import org.acbrtc.IceCandidate;

import android.util.Log;

import com.alicecallsbob.fcsdk.android.phone.impl.CallServerMessageBuilder;
import com.alicecallsbob.fcsdk.android.phone.impl.PhoneImpl;

public class CandidateMessageHandler extends CallServerMessageHandler
{
	public CandidateMessageHandler(PhoneImpl callManager)
	{
		super(callManager);
	}

	@Override
	public void handleServerMessage(JSONObject serverMessage) throws JSONException
	{
		final String callID = serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_CALL_ID);
		final String candidate = serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_CANDIDATE);
		final String lineIndex = serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_CANDIDATE_LINE_INDEX);
		final String mid = serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_CANDIDATE_MID);

		final IceCandidate c = new IceCandidate(mid, Integer.valueOf(lineIndex), candidate);
		
		getCallManager().handleIceCandidate(callID, c);
	}
}