/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.phone.impl.handlers;

import org.json.JSONException;
import org.json.JSONObject;

import com.alicecallsbob.fcsdk.android.phone.impl.PhoneImpl;
import com.alicecallsbob.fcsdk.android.phone.impl.CallServerMessageBuilder;

import android.util.Log;

/**
 * Incoming OFFER message consists of,
 *
 * "type" - "OFFER",
 * "remoteParty" - String,
 * "callId" - integer,
 * "sdp" - String
 */
public class OfferMessageHandler extends CallServerMessageHandler
{
	public OfferMessageHandler(PhoneImpl callManager)
	{
		super(callManager);
	}

	@Override
	public void handleServerMessage(JSONObject serverMessage) throws JSONException
	{
		StringBuilder	sb = new StringBuilder();
		sb.append("incoming OFFER:-\r\n");
		sb.append(serverMessage.toString(4));
		Log.v("OfferMessageHandler", sb.toString());

		final String	callID =
				serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_CALL_ID);
		final String	remoteParty =
				serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_REMOTE_PARTY);
		final String	sdp =
				serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_SDP);

		getCallManager().handleOffer(callID, remoteParty, sdp);
	}
}
