/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.uc.impl.handler;

import org.json.JSONException;
import org.json.JSONObject;

import com.alicecallsbob.fcsdk.android.uc.impl.UCImpl;
import com.alicecallsbob.fcsdk.android.uc.impl.UCServerMessageBuilder;

/**
 * A handler for GENERIC_ERROR server messages.
 */
public class GenericErrorHandler extends UCServerMessageHandler
{
	/**
	 * Constructor.
	 *
	 * @param uc UCImpl instance
	 */
	public GenericErrorHandler(final UCImpl uc)
	{
		super(uc);
	}

	@Override
	public final void handleServerMessage(final JSONObject serverMessage)
			throws JSONException
	{
		final String error =
				serverMessage.getString(UCServerMessageBuilder.MESSAGE_FIELD_ERROR);
		final String reason =
				serverMessage.getString(UCServerMessageBuilder.MESSAGE_FIELD_REASON);

		getUc().onGenericError(error, reason);
	}
}
