/*
 * Mon Jun 26 09:41:27 BST 2017 CafeX Communications
 */
package com.alicecallsbob.fcsdk.android.uc.impl.handler;

import org.json.JSONObject;

import android.util.Log;

import com.alicecallsbob.fcsdk.android.phone.impl.CallServerMessageBuilder;
import com.alicecallsbob.fcsdk.android.uc.impl.UCImpl;

public class InitialisationSuccessHandler extends UCServerMessageHandler
{
	private final String TAG = "InitialisationSuccessHandler";
	
    public InitialisationSuccessHandler(UCImpl uc)
    {
        super(uc);
    }

    @Override
    public void handleServerMessage(JSONObject serverMessage)
    {       
        int swiftVersion = 0;        
        try 
        {
			final String version = serverMessage.getString(CallServerMessageBuilder.MESSAGE_FIELD_SWIFT_VERSION);
			
			swiftVersion = Integer.valueOf(version);

        	Log.d(TAG, "SWIFT version number " + version);
        } 
        catch (Exception e) 
		{
        	Log.e(TAG, "Could not determine SWIFT version number.");
		}
        
        getUc().setSwiftVersion(swiftVersion);

        getUc().onSessionStarted();
    }
}
